/**
 * angular-text-input-highlight-fork - A component that can highlight parts of text in a textarea. Useful for displaying mentions etc
 * @version v1.6.0
 * @author Matt Lewis
 * @link https://github.com/mattlewis92/angular-text-input-highlight#readme
 * @license MIT
 */
!function(e,t){"object"==typeof exports&&"object"==typeof module?module.exports=t(require("@angular/core"),require("@angular/common")):"function"==typeof define&&define.amd?define(["@angular/core","@angular/common"],t):"object"==typeof exports?exports.angularTextInputHighlight=t(require("@angular/core"),require("@angular/common")):e.angularTextInputHighlight=t(e.ng.core,e.ng.common)}("undefined"!=typeof self?self:this,function(e,t){return function(e){function t(i){if(n[i])return n[i].exports;var r=n[i]={i:i,l:!1,exports:{}};return e[i].call(r.exports,r,r.exports,t),r.l=!0,r.exports}var n={};return t.m=e,t.c=n,t.d=function(e,n,i){t.o(e,n)||Object.defineProperty(e,n,{configurable:!1,enumerable:!0,get:i})},t.n=function(e){var n=e&&e.__esModule?function(){return e.default}:function(){return e};return t.d(n,"a",n),n},t.o=function(e,t){return Object.prototype.hasOwnProperty.call(e,t)},t.p="",t(t.s=1)}([function(t,n){t.exports=e},function(e,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),function(e){for(var n in e)t.hasOwnProperty(n)||(t[n]=e[n])}(n(2))},function(e,t,n){"use strict";var i=this&&this.__decorate||function(e,t,n,i){var r,o=arguments.length,s=o<3?t:null===i?i=Object.getOwnPropertyDescriptor(t,n):i;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)s=Reflect.decorate(e,t,n,i);else for(var a=e.length-1;a>=0;a--)(r=e[a])&&(s=(o<3?r(s):o>3?r(t,n,s):r(t,n))||s);return o>3&&s&&Object.defineProperty(t,n,s),s};Object.defineProperty(t,"__esModule",{value:!0});var r=n(0),o=n(3),s=n(4),a=n(5),l=n(6),u=function(){function e(){}return e=i([r.NgModule({declarations:[s.TextInputHighlightComponent,a.TextInputHighlightContainerDirective,l.TextInputElementDirective],imports:[o.CommonModule],exports:[s.TextInputHighlightComponent,a.TextInputHighlightContainerDirective,l.TextInputElementDirective]})],e)}();t.TextInputHighlightModule=u},function(e,n){e.exports=t},function(e,t,n){"use strict";function i(e,t){return t.indices.start<e&&e<t.indices.end}function r(e,t){return i(t.indices.start,e)||i(t.indices.end,e)}function o(e,t,n){return e.left<t&&t<e.right&&e.top<n&&n<e.bottom}function s(e){return e.replace(/</g,"&lt;").replace(/>/g,"&gt;")}var a=this&&this.__decorate||function(e,t,n,i){var r,o=arguments.length,s=o<3?t:null===i?i=Object.getOwnPropertyDescriptor(t,n):i;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)s=Reflect.decorate(e,t,n,i);else for(var a=e.length-1;a>=0;a--)(r=e[a])&&(s=(o<3?r(s):o>3?r(t,n,s):r(t,n))||s);return o>3&&s&&Object.defineProperty(t,n,s),s},l=this&&this.__metadata||function(e,t){if("object"==typeof Reflect&&"function"==typeof Reflect.metadata)return Reflect.metadata(e,t)};Object.defineProperty(t,"__esModule",{value:!0});var u=n(0),c=Object.freeze(["direction","boxSizing","width","height","overflowX","overflowY","borderTopWidth","borderRightWidth","borderBottomWidth","borderLeftWidth","borderStyle","paddingTop","paddingRight","paddingBottom","paddingLeft","fontStyle","fontVariant","fontWeight","fontStretch","fontSize","fontSizeAdjust","lineHeight","fontFamily","textAlign","textTransform","textIndent","textDecoration","letterSpacing","wordSpacing","tabSize","MozTabSize"]),h=function(){function e(e,t){this.renderer=e,this.cdr=t,this.tagCssClass="",this.tags=[],this.tagClick=new u.EventEmitter,this.tagMouseEnter=new u.EventEmitter,this.tagMouseLeave=new u.EventEmitter,this.highlightElementContainerStyle={},this.textareaEventListeners=[],this.isDestroyed=!1}return e.prototype.refresh=function(){var e=this,t=getComputedStyle(this.textInputElement);c.forEach(function(n){e.highlightElementContainerStyle[n]=t[n]})},e.prototype.ngOnChanges=function(e){e.textInputElement&&this.textInputElementChanged(),(e.tags||e.tagCssClass||e.textInputValue)&&this.addTags()},e.prototype.ngOnDestroy=function(){this.isDestroyed=!0,this.textareaEventListeners.forEach(function(e){return e()})},e.prototype.onWindowResize=function(){this.refresh()},e.prototype.textInputElementChanged=function(){var e=this,t=this.textInputElement.tagName.toLowerCase();if("textarea"!==t)throw new Error("The angular-text-input-highlight component must be passed a textarea to the `textInputElement` input. Instead received a "+t);setTimeout(function(){if(!e.isDestroyed){if(e.refresh(),e.textareaEventListeners.forEach(function(e){return e()}),e.textareaEventListeners=[e.renderer.listen(e.textInputElement,"input",function(){e.addTags()}),e.renderer.listen(e.textInputElement,"scroll",function(){e.highlightElement.nativeElement.scrollTop=e.textInputElement.scrollTop,e.highlightTagElements=e.highlightTagElements.map(function(e){return e.clientRect=e.element.getBoundingClientRect(),e})})],e.tagClick.observers.length>0){var t=e.renderer.listen(e.textInputElement,"click",function(t){e.handleTextareaMouseEvent(t,"click")});e.textareaEventListeners.push(t)}if(e.tagMouseEnter.observers.length>0){var n=e.renderer.listen(e.textInputElement,"mousemove",function(t){e.handleTextareaMouseEvent(t,"mousemove")}),i=e.renderer.listen(e.textInputElement,"mouseleave",function(t){e.mouseHoveredTag&&(e.tagMouseLeave.emit(e.mouseHoveredTag),e.mouseHoveredTag=void 0)});e.textareaEventListeners.push(n),e.textareaEventListeners.push(i)}e.addTags()}})},e.prototype.addTags=function(){var e=this,t=void 0!==this.textInputValue?this.textInputValue:this.textInputElement.value,n=[],i=[];this.tags.slice().sort(function(e,t){return e.indices.start-t.indices.start}).forEach(function(o){if(o.indices.start>o.indices.end)throw new Error("Highlight tag with indices ["+o.indices.start+", "+o.indices.end+"] cannot start after it ends.");n.forEach(function(e){if(r(e,o))throw new Error("Highlight tag with indices ["+o.indices.start+", "+o.indices.end+"] overlaps with tag ["+e.indices.start+", "+e.indices.end+"]")});var a=o.indices.end-o.indices.start,l=t.slice(o.indices.start,o.indices.end);if(l.length===a){var u=n.length>0?n[n.length-1].indices.end:0,c=t.slice(u,o.indices.start);i.push(s(c));var h=o.cssClass||e.tagCssClass,g="text-highlight-tag-id-"+e.tags.indexOf(o);i.push('<span class="text-highlight-tag '+g+" "+h+'">'+s(l)+"</span>"),n.push(o)}});var o=n.length>0?n[n.length-1].indices.end:0,a=t.slice(o);i.push(s(a)),i.push("&nbsp;"),this.highlightedText=i.join(""),this.cdr.detectChanges(),this.highlightTagElements=Array.from(this.highlightElement.nativeElement.getElementsByTagName("span")).map(function(e){return{element:e,clientRect:e.getBoundingClientRect()}})},e.prototype.handleTextareaMouseEvent=function(e,t){var n=this.highlightTagElements.findIndex(function(t){return o(t.clientRect,e.clientX,e.clientY)});if(n>-1){var i=this.highlightTagElements[n].element,r=Array.from(i.classList).find(function(e){return e.startsWith("text-highlight-tag-id-")});if(r){var s=r.replace("text-highlight-tag-id-",""),a=this.tags[+s],l={tag:a,target:i,event:e};"click"===t?this.tagClick.emit(l):this.mouseHoveredTag||(this.mouseHoveredTag=l,this.tagMouseEnter.emit(l))}}else"mousemove"===t&&this.mouseHoveredTag&&(this.mouseHoveredTag.event=e,this.tagMouseLeave.emit(this.mouseHoveredTag),this.mouseHoveredTag=void 0)},a([u.Input(),l("design:type",String)],e.prototype,"tagCssClass",void 0),a([u.Input(),l("design:type",Array)],e.prototype,"tags",void 0),a([u.Input(),l("design:type",HTMLTextAreaElement)],e.prototype,"textInputElement",void 0),a([u.Input(),l("design:type",String)],e.prototype,"textInputValue",void 0),a([u.Output(),l("design:type",Object)],e.prototype,"tagClick",void 0),a([u.Output(),l("design:type",Object)],e.prototype,"tagMouseEnter",void 0),a([u.Output(),l("design:type",Object)],e.prototype,"tagMouseLeave",void 0),a([u.ViewChild("highlightElement"),l("design:type",u.ElementRef)],e.prototype,"highlightElement",void 0),a([u.HostListener("window:resize"),l("design:type",Function),l("design:paramtypes",[]),l("design:returntype",void 0)],e.prototype,"onWindowResize",null),e=a([u.Component({selector:"mwl-text-input-highlight",template:'\n    <div\n      class="text-highlight-element"\n      [ngStyle]="highlightElementContainerStyle"\n      [innerHtml]="highlightedText"\n      #highlightElement\n    ></div>\n  '}),l("design:paramtypes",[u.Renderer2,u.ChangeDetectorRef])],e)}();t.TextInputHighlightComponent=h},function(e,t,n){"use strict";var i=this&&this.__decorate||function(e,t,n,i){var r,o=arguments.length,s=o<3?t:null===i?i=Object.getOwnPropertyDescriptor(t,n):i;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)s=Reflect.decorate(e,t,n,i);else for(var a=e.length-1;a>=0;a--)(r=e[a])&&(s=(o<3?r(s):o>3?r(t,n,s):r(t,n))||s);return o>3&&s&&Object.defineProperty(t,n,s),s};Object.defineProperty(t,"__esModule",{value:!0});var r=n(0),o=function(){function e(){}return e=i([r.Directive({selector:"[mwlTextInputHighlightContainer]",host:{"[class.text-input-highlight-container]":"true"}})],e)}();t.TextInputHighlightContainerDirective=o},function(e,t,n){"use strict";var i=this&&this.__decorate||function(e,t,n,i){var r,o=arguments.length,s=o<3?t:null===i?i=Object.getOwnPropertyDescriptor(t,n):i;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)s=Reflect.decorate(e,t,n,i);else for(var a=e.length-1;a>=0;a--)(r=e[a])&&(s=(o<3?r(s):o>3?r(t,n,s):r(t,n))||s);return o>3&&s&&Object.defineProperty(t,n,s),s};Object.defineProperty(t,"__esModule",{value:!0});var r=n(0),o=function(){function e(){}return e=i([r.Directive({selector:"textarea[mwlTextInputElement]",host:{"[class.text-input-element]":"true"}})],e)}();t.TextInputElementDirective=o}])});
//# sourceMappingURL=angular-text-input-highlight.umd.min.js.map